import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import java.awt.*;
import java.io.*;



public class PlayGui extends JPanel
{
      public static final int WIDTH = 600;
      public static final int HEIGHT = 600;

      public static final int NO_FILE=2, PLAYING=3, STOPPED=4, PAUSED=5;
      int status = PLAYING;

      JFrame frame;

      Vector songVector;
      Vector queueVector;

      Vector offlineDisabledComponents;

      JPanel statusBar;
      JLabel statusArea;

      JList songList = new JList();
      JList queueList = new JList();

      JPopupMenu songlistPopup;

      JMenu pMnuTag;
      JMenuItem tMnuRemoveTag;
      JMenu tagMenu;

      Vector tagVec = new Vector();

      JTextField searchField;
      JButton searchButton;

      JButton togglePauseResumeButton;

      JTabbedPane tabs;

      Client cli = null;

      JMenuItem toggleConnect;
      JMenuItem updateSongs;
      JMenuItem updateTags;
      JMenuItem updateQueue;

      boolean connected = false;

      int histlines = 0;
      int queuelines = 0;


      String server;
      int port;

      int debug;

      public PlayGui(JFrame parent,int port, String server, int debug)
      {
	 frame = parent;
	 this.port = port;
	 this.server = server;
	 this.debug = debug;

	 SpringLayout layout = new SpringLayout();
	 setLayout(layout);

	 offlineDisabledComponents = new Vector();

	 // status bar
	 statusBar = new JPanel();
	 SpringLayout statusBarLayout = new SpringLayout();
	 statusBar.setLayout(statusBarLayout);
	 statusArea = new JLabel("Not connected");
	 statusBar.setPreferredSize(new Dimension(WIDTH,22));
	 statusBar.add(statusArea);
	 statusBarLayout.putConstraint(SpringLayout.WEST, statusArea, 2, SpringLayout.WEST, statusBar); 
	 statusBarLayout.putConstraint(SpringLayout.NORTH, statusArea, 2, SpringLayout.NORTH, statusBar); 
	 add(statusBar);
	 layout.putConstraint(SpringLayout.SOUTH, statusBar, 0, SpringLayout.SOUTH, this);
 	 layout.putConstraint(SpringLayout.EAST, statusBar, 0, SpringLayout.EAST, this); 
	 layout.putConstraint(SpringLayout.WEST, statusBar, 0, SpringLayout.WEST, this); 

	 statusBar.setBorder(BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

	 
	 // queueList and songList stuff

	 JScrollPane songListScroll = new JScrollPane(songList);
	 JPanel songListButtons = new JPanel();
//	 songListButtons.setPreferredSize(new Dimension(WIDTH,25));

	 JPanel songPanel = new JPanel();

	 JScrollPane queueListScroll = new JScrollPane(queueList);
	 JPanel queueListButtons = new JPanel();
//	 queueListButtons.setPreferredSize(new Dimension(WIDTH,25));

	 JPanel queuePanel = new JPanel();

	 queueList.addMouseListener(new PlMouseListener(this,queueList,PlMouseListener.PLAY));
	 songList.addMouseListener(new PlMouseListener(this,songList,PlMouseListener.SONG));

	 songList.setFont(new Font("SansSerif",Font.PLAIN,10));
	 queueList.setFont(new Font("SansSerif",Font.PLAIN,10));

	 queueList.setCellRenderer(new jListCellRenderer(this));

	 songPanel.add(songListScroll);
	 songPanel.add(songListButtons);

	 queuePanel.add(queueListScroll);
	 queuePanel.add(queueListButtons);



	 SpringLayout songPanelLayout = new SpringLayout();
	 songPanel.setLayout(songPanelLayout);

	 songPanelLayout.putConstraint(SpringLayout.EAST, songListScroll,   0, SpringLayout.EAST, songPanel); 
	 songPanelLayout.putConstraint(SpringLayout.WEST, songListScroll,   0, SpringLayout.WEST, songPanel); 
	 songPanelLayout.putConstraint(SpringLayout.EAST, songListButtons,  0, SpringLayout.EAST, songPanel); 
	 songPanelLayout.putConstraint(SpringLayout.WEST, songListButtons,  0, SpringLayout.WEST, songPanel); 

	 songPanelLayout.putConstraint(SpringLayout.SOUTH, songListButtons, 0, SpringLayout.SOUTH, songPanel); 
	 songPanelLayout.putConstraint(SpringLayout.SOUTH, songListScroll,  0, SpringLayout.NORTH, songListButtons); 
	 songPanelLayout.putConstraint(SpringLayout.NORTH, songListScroll,  0, SpringLayout.NORTH, songPanel); 


	 SpringLayout queuePanelLayout = new SpringLayout();
	 queuePanel.setLayout(queuePanelLayout);

	 queuePanelLayout.putConstraint(SpringLayout.EAST, queueListScroll,   0, SpringLayout.EAST, queuePanel); 
	 queuePanelLayout.putConstraint(SpringLayout.WEST, queueListScroll,   0, SpringLayout.WEST, queuePanel); 
	 queuePanelLayout.putConstraint(SpringLayout.EAST, queueListButtons,  0, SpringLayout.EAST, queuePanel); 
	 queuePanelLayout.putConstraint(SpringLayout.WEST, queueListButtons,  0, SpringLayout.WEST, queuePanel); 

	 queuePanelLayout.putConstraint(SpringLayout.SOUTH, queueListButtons, 0, SpringLayout.SOUTH, queuePanel); 
	 queuePanelLayout.putConstraint(SpringLayout.SOUTH, queueListScroll,  0, SpringLayout.NORTH, queueListButtons); 
	 queuePanelLayout.putConstraint(SpringLayout.NORTH, queueListScroll,  0, SpringLayout.NORTH, queuePanel); 
	

	 //tabbed pane stuff
	 tabs = new JTabbedPane(JTabbedPane.TOP);
	 tabs.setPreferredSize(new Dimension(WIDTH-135, HEIGHT-10-10-50-100));
	 add(tabs);

	 layout.putConstraint(SpringLayout.SOUTH, tabs, 0, SpringLayout.NORTH, statusBar); 
	 layout.putConstraint(SpringLayout.NORTH, tabs, 0, SpringLayout.NORTH, this); 
	 layout.putConstraint(SpringLayout.EAST, tabs, 0, SpringLayout.EAST, this); 
	 layout.putConstraint(SpringLayout.WEST, tabs, 0, SpringLayout.WEST, this); 

	 tabs.addTab("Library",songPanel);
	 tabs.addTab("Queue",queuePanel);

	 // popup menu stuff

	 songlistPopup = new JPopupMenu();
	 
	 JMenuItem pMnuQueueUp = new JMenuItem("Queue Up");
	 pMnuQueueUp.addActionListener(new UActionListener(this,UActionListener.QUEUE));
	 JButton pButQueueUp = new JButton("Queue Up");
	 pButQueueUp.addActionListener(new UActionListener(this,UActionListener.QUEUE));	 

	 JMenuItem pMnuQueueUpShuff = new JMenuItem("Queue Up Shuffled");
	 pMnuQueueUpShuff.addActionListener(new UActionListener(this,UActionListener.QUEUE_SHUFFLED));
	 JButton pButQueueUpShuff = new JButton("Shuffle Up");
	 pButQueueUpShuff.addActionListener(new UActionListener(this,UActionListener.QUEUE_SHUFFLED));

	 pMnuTag = new JMenu("Tag");
	 JButton tagButton = new JButton("Tag ...");
	 tagButton.addActionListener(new UActionListener(this,UActionListener.TAG_BUTTON));
	 JButton untagButton = new JButton("Untag ...");
	 untagButton.addActionListener(new UActionListener(this,UActionListener.UNTAG));



	 
	 songlistPopup.add(pMnuQueueUp);
	 songlistPopup.add(pMnuQueueUpShuff);
	 songlistPopup.add(pMnuTag);

	 songListButtons.add(pButQueueUp);
	 songListButtons.add(pButQueueUpShuff);
	 songListButtons.add(tagButton);
	 songListButtons.add(untagButton);

	 offlineDisabledComponents.add(pButQueueUp); 
	 offlineDisabledComponents.add(pButQueueUpShuff);
	 offlineDisabledComponents.add(tagButton);
	 offlineDisabledComponents.add(untagButton);


	 JMenu clearMnu = new JMenu("Clear");
	 offlineDisabledComponents.add(clearMnu);

	 JButton pButRemove = new JButton("Remove");
	 pButRemove.addActionListener(new UActionListener(this,UActionListener.QUEUE_REMOVE_BUTTON));

	 togglePauseResumeButton = new JButton("Pause");
	 togglePauseResumeButton.addActionListener(new UActionListener(this,UActionListener.TOGGLE_PAUSE_RESUME));

	 JButton pButNxtSng = new JButton("Next");
	 pButNxtSng.addActionListener(new UActionListener(this,UActionListener.NEXT));

	 JButton pButPrvSng = new JButton("Previous");
	 pButPrvSng.addActionListener(new UActionListener(this,UActionListener.PREV));

	 JMenuItem pMnuClrFtr = new JMenuItem("Future");
	 pMnuClrFtr.addActionListener(new UActionListener(this,UActionListener.CLEAR_FUTURE));

	 JMenuItem pMnuClrHis = new JMenuItem("History");
	 pMnuClrHis.addActionListener(new UActionListener(this,UActionListener.CLEAR_HISTORY));

	 JMenuItem pMnuClr = new JMenuItem("All");
	 pMnuClr.addActionListener(new UActionListener(this,UActionListener.CLEAR));
	 JButton pButClr = new JButton("Clear");
	 pButClr.addActionListener(new UActionListener(this,UActionListener.CLEAR));


	 clearMnu.add(pMnuClr);
	 clearMnu.add(pMnuClrFtr);
	 clearMnu.add(pMnuClrHis);

	 queueListButtons.add(togglePauseResumeButton);
	 queueListButtons.add(pButNxtSng);
	 queueListButtons.add(pButPrvSng);
	 queueListButtons.add(pButRemove);
	 queueListButtons.add(pButClr);

	 offlineDisabledComponents.add(togglePauseResumeButton);
	 offlineDisabledComponents.add(pButNxtSng);
	 offlineDisabledComponents.add(pButPrvSng); 
	 offlineDisabledComponents.add(pButRemove);
	 offlineDisabledComponents.add(pButClr);
	 
    

	 // menu stuff

	 toggleConnect = new JMenuItem("Connect");
	 toggleConnect.addActionListener( new TcActionListener(this) );

	 updateSongs = new JMenuItem("Update Song List");
	 updateSongs.addActionListener(new UActionListener(this,UActionListener.SONG));
	 offlineDisabledComponents.add(updateSongs);

	 updateTags = new JMenuItem("Update Tag List");
	 updateSongs.addActionListener(new UActionListener(this,UActionListener.UPDATE_TAGS));
	 offlineDisabledComponents.add(updateTags);

	 updateQueue = new JMenuItem("Update Queue");
	 updateQueue.addActionListener(new UActionListener(this,UActionListener.PLAY));
	 offlineDisabledComponents.add(updateQueue);

	 JMenuBar jmb = new JMenuBar();

	 JMenu srv = new JMenu("Server");
	 jmb.add(srv);
	 srv.add(toggleConnect);
	 srv.add(updateSongs);
	 srv.add(updateTags);
	 srv.add(updateQueue);

	 tagMenu = new JMenu("Tag");
	 offlineDisabledComponents.add(tagMenu);

	 JMenuItem tMnuNewTag = new JMenuItem("New tag ...");
	 tMnuNewTag.addActionListener(new UActionListener(this,UActionListener.NEWTAG));
	 tagMenu.add(tMnuNewTag);

	 tMnuRemoveTag = new JMenuItem("Remove tag ...");
	 tMnuRemoveTag.addActionListener(new UActionListener(this,UActionListener.REMOVE_TAG));
	 tagMenu.add(tMnuRemoveTag);

	 JMenuItem tMnuUntag = new JMenuItem("Untag ...");
	 tagMenu.add(tMnuUntag);

	 jmb.add(tagMenu);
	 jmb.add(clearMnu);


	 // search bar (on the menu) stuff

	 searchField = new JTextField(15);
	 ImageIcon searchIcon = new ImageIcon("icons/search.png");
	 searchButton = new JButton(searchIcon);
	 searchButton.setPreferredSize(
	    new Dimension(searchIcon.getIconWidth() + 2,
			  searchIcon.getIconHeight() + 2));

	 searchButton.setBorder(BorderFactory.createEmptyBorder());

	 searchButton.addActionListener(new UActionListener(this,UActionListener.SEARCH));
	 searchField.addActionListener(new UActionListener(this,UActionListener.SEARCH));
	 

	 SpringLayout menuLayout = new SpringLayout();
	 jmb.setLayout(menuLayout);

	 jmb.add(searchField);
	 jmb.add(searchButton);

	 offlineDisabledComponents.add(searchField);
	 offlineDisabledComponents.add(searchButton);

	 menuLayout.putConstraint(SpringLayout.WEST, srv, 0, SpringLayout.WEST, jmb); 
	 menuLayout.putConstraint(SpringLayout.WEST, tagMenu, 0, SpringLayout.EAST, srv); 
	 menuLayout.putConstraint(SpringLayout.WEST, clearMnu, 0, SpringLayout.EAST, tagMenu); 
	 menuLayout.putConstraint(SpringLayout.EAST, searchButton, 0, SpringLayout.EAST, jmb); 
	 menuLayout.putConstraint(SpringLayout.EAST, searchField, 0, SpringLayout.WEST, searchButton); 

	 jmb.setPreferredSize(new Dimension(WIDTH,22));
	 
	 
	 
	 parent.setJMenuBar(jmb);

	 Iterator it = offlineDisabledComponents.iterator();
	 while(it.hasNext())
	    ((Component)it.next()).setEnabled(false);
      }


      public void connectToServer(String host, int port)
      {
	 toggleConnect.setEnabled(false);
	 toggleConnect.setText("Connecting...");	 
	 setStatus("Connecting to " + host + " on port " + port + "...");

	 cli = new Client(host,port,this);
	 String retval = cli.connect();

	 if (retval == null)
	 {
	    toggleConnect.setText("Disconnect");
	    setStatus("Connected to " + host);
	    connected = true;
	    cli.start();
	    Iterator it = offlineDisabledComponents.iterator(); 
	    while(it.hasNext()) 
	       ((Component)it.next()).setEnabled(true); 

	 }
	 else
	 {
	    toggleConnect.setText("Connect");
	    setStatus("Connection failed");
	    reportError(retval);
	 }
	 
	 toggleConnect.setEnabled(true);	 
      }
      
      public void disconnectFromServer()
      {
	 if(!connected)
	 {
	    if(debug > 1)
	       System.out.println("disconnect should only happen while connected");
	    return;
	 }
	 
	 toggleConnect.setEnabled(false);
	 toggleConnect.setText("Disconnecting...");
	 setStatus("Disconnecting...");
	 
	 cli.disconnect();
	 connected = false;
         Iterator it = offlineDisabledComponents.iterator(); 
         while(it.hasNext()) 
            ((Component)it.next()).setEnabled(false); 
	 cli = null;


	 toggleConnect.setEnabled(true);
	 toggleConnect.setText("Connect");
	 setStatus("Not connected");
      }
      
      public void updateSongList()
      {
	 songSearch("");
      }

      public void search()
      {
	 tabs.setSelectedIndex(0);
	 songSearch(searchField.getText());
      }

      public void songSearch(String expr)
      {
	 songVector = new Vector();
	 String allsongs;
	 
	 if(connected)
	 {
	    if(expr.length() == 0)
	    {
	       allsongs = cli.listSongs();
	    }
	    else
	    {
	       allsongs = cli.tagSearch(expr);
	       searchField.selectAll();
	    }
	    
	    if(allsongs != null)
	       songVector = Utility.stringToVec(allsongs);
	 }

	 songList.setListData(songVector);
      }


      public void updateTags()
      {
	 if(debug > 2)
	    System.out.println("Updating tags");
	 if(connected)
	 {
	    String taglist = cli.listTags();
	    if(taglist != null)
	       tagVec = Utility.stringToVec(taglist);

	    pMnuTag.removeAll();

	    for (int i = 0 ; i < tagVec.size() ; i++)
	    {
	       JMenuItem pj = new JMenuItem((String) tagVec.get(i));

	       pj.addActionListener(new TActionListener((String)tagVec.get(i), TActionListener.TAG,this));

	       pMnuTag.add(pj);
	    }


	 }	 

      }

      public void removeFromQueueButton()
      {
	 int val = queueList.getSelectedIndex();
	 if(val == -1)
	 {
	    if(debug > 1)
	       System.out.println("No selected values.  Oh well.");
	    return;
	 }
	 
	 if(histlines - val > 0)
	    cli.removeFromHistory(val);
	 else if (val - histlines > 0)
	    cli.removeFromToplay(val-histlines-1);
	 else
	 {
	    cli.next();
	    cli.removeFromHistory(histlines-1);
	 }

	 updateQueue();
      }

     

      public void clearQueue()
      {
	 cli.clearToplay();
	 cli.next();
	 cli.clearHistory();

	 updateQueue();
      }

      public void clearToplay()
      {
	 cli.clearToplay();
	 updateQueue();
      }

      public void clearHistory()
      {
	 cli.clearHistory();
	 updateQueue();
      }

      public void next()
      {
	 cli.next();
	 updateQueue();
      }

      public void prev()
      {
	 cli.prev();
	 updateQueue();
      }

      public void jumpToIndex (int index)
      {
	 if(histlines - index > 0)
	    cli.prevN(histlines-index);
	 else if (index - histlines > 0)
	    cli.nextN(index-histlines);
	 // else we're already there


	 updateQueue();
      }

      public void queueSongByIndex(int index)
      {
	 String song = (String)songVector.get(index);
	 if(song != null)
	 {
	    cli.queueUp( song );
	    updateQueue();
	 }
      }

      public void queueUp()
      {
	 cli.queueUpMult( songList.getSelectedValues() );

	 updateQueue();
      }

      public void tagSomething(String tag)
      {
	 cli.tagMult(songList.getSelectedValues() , tag);
      }

      public void tagWindow()
      {
	 Object[] opts = tagVec.toArray();

	 String s = (String)JOptionPane.showInputDialog(
	    frame,
	    "Tag " + (opts.length == 1 ? "this song" : "these songs")
	    + " as:",
	    "Select tag",
	    JOptionPane.QUESTION_MESSAGE,
	    null,
	    opts,
	    null);

	 if(s != null)
	    tagSomething(s);
      }

      public void untagWindow()
      {
	 Object[] sels = songList.getSelectedValues();
	 Collection tfa = null;

	 for (int i = 0 ; i < sels.length ; i++)
	 {
	    String tagsFS = cli.listTagsForSong((String)sels[i]);
	    if(debug > 1)
	       System.out.println("Recieved tags: " + tagsFS + " for song " + sels[i]);
	    if(tagsFS != null)
	    {
	       Collection tfs = new TreeSet();
	       
	       StringTokenizer st = new StringTokenizer(tagsFS,"\n");
	       while(st.hasMoreTokens())
		  tfs.add(st.nextToken());		  
	  
	       if(tfa == null)
		  tfa = tfs;
	       else
		  tfa.retainAll(tfs);
	    }
	    else if (debug > 0)
	       System.out.println("Null tags for song: " + sels[i]);
	 }

	 if(tfa == null || tfa.size() == 0)
	    JOptionPane.showMessageDialog(frame, "The selected songs have no tags in common", "No matching tags",
					  JOptionPane.INFORMATION_MESSAGE);
	 else
	 {
	    Collection currentTags = new TreeSet(tfa);

	    String toUntag = (String)JOptionPane.showInputDialog( 
	       frame, 
	       "Untag " + (sels.length == 1 ? "this song" : "these songs") 
	       + " from:", 
	       "Select tag", 
	       JOptionPane.QUESTION_MESSAGE, 
	       null, 
	       currentTags.toArray(), 
	       null); 
 
	    if(toUntag != null) 
	       cli.untagMult(sels,toUntag); 
	 }
      }

      public void newTagDotDotDot()
      {
//	 String input = JOptionPane.showInputDialog(frame,"Enter a name for the new tag","Name the tag",
//						    JOptionPane.INFORMATION_MESSAGE);
	 String input = JOptionPane.showInputDialog(frame,"Enter a name for the new tag");
	 if(input != null)
	 {
	    cli.newTag(input);
	    updateTags();
	 }
      }

      public void removeTagDotDotDot()
      {
	 updateTags();

	 Object[] opts = tagVec.toArray();

	 String s = (String)JOptionPane.showInputDialog(
	    frame,
	    "Select tag to delete.  Please be careful.",
	    "Remove tag",
	    JOptionPane.QUESTION_MESSAGE,
	    null,
	    opts,
	    null);

	 if(s != null)
	 {
	    cli.removeTag(s);
	    updateTags();
	 }
      }


      public void togglePauseResume()
      {
	 if(status == PAUSED)
	    cli.resumee();
	 else if(status == STOPPED)
	    cli.startt();
	 else if(status == PLAYING)
	    cli.pausee();
      }

      public void queueUpShuffled()
      {
	 cli.queueUpMult( Utility.shuffle( songList.getSelectedValues() ) );

	 updateQueue();
      }

     


      public void updateQueue()
      {
	 queueVector = new Vector();

	 if(connected)
	 {
	    String history = cli.listHistory();

	    String nowPlaying = cli.nowPlaying();
	    String playsongs = cli.listQueue();
	    
	    histlines = putByLine(history,queueVector);
	    if(nowPlaying != null)
	    {
	       if(nowPlaying.equals("null"))
	       {
		  if(history == null || history.trim().length() == 0)
		     queueVector.add("<Empty>");
		  else
		     queueVector.add("<No song>");
	       }	       
	       else
		  queueVector.add(nowPlaying);
	    }
	    queuelines = putByLine(playsongs,queueVector);

	    queueList.setListData(queueVector);
	 
//	    queueList.setSelectedIndex(histlines);
	    queueList.ensureIndexIsVisible(histlines);
	 }
	 else
	 {
	    queueVector.add("<Empty>"); 
	    queueList.setListData(queueVector);
	    queueList.setSelectedIndex(0); 
            queueList.ensureIndexIsVisible(0); 
	 }
      }

      public int putByLine(String s, Vector v)
      {
	 int lines = 0;
	 StringBuffer t = new StringBuffer();
	 if(s != null)
	 {
	    for (int i = 0 ; i < s.length() ; i++)
	    {
	       if (s.charAt(i) == '\n')
	       {
		  v.add(t.toString());
		  t = new StringBuffer();
		  lines++;
	       }
	       else
		  t.append(s.charAt(i));
	    }
	 }

	 return lines;
      }

      public static void main (String[] args)
      {
	 Hashtable config = null;

	 if (args.length > 0)
	 {
	    if (args[0].equals("--help"))
	    {
	       System.out.println("PlayGui : A program to remotely control a music player");
	       System.out.println("  If a file is passed in on the command line, it is used as");
	       System.out.println("  the configuration file.  Otherwise /etc/playgui is used.");
	       System.exit(0);
	    }
	    else 
	    {
	       // turns keys to lowercase (among other things)
	       config = Utility.parseConfig(args[0]);
	    }
	 }
	 else if( (new File("/etc/playgui.conf")).exists() )
	    config = Utility.parseConfig("/etc/playgui.conf");
	 else
	 {					
	    System.out.println("No configuration file found.  Please put one in /etc/playgui.conf");
	    System.out.println("or pass the location of one in on the commandline.");
	    System.exit(2);
	 }

	 if (config == null)
	    Utility.die("Config is null after reading and shouldn't be");

	 int debug = Integer.parseInt(Utility.configSet(config,"debug","2"));
	 if (debug > 4 || debug < 0)
	    Utility.die("Invalid debug value : " + debug);

	 int port = Integer.parseInt(Utility.configSet(config,"port","10332"));
	 if (port > 65535 || port < 1)
	    Utility.die("Invalid port value : " + port);

	 String server = Utility.configSet(config, "server", "130.58.235.118");

	 String autoconnectStr = Utility.configSet(config, "autoconnect", "yes").toLowerCase();
	 boolean autoconnect = autoconnectStr.equals("yes") || autoconnectStr.equals("true");

	 String autolistsongsStr = Utility.configSet(config, "autolistsongs", "yes").toLowerCase();
	 boolean autolistsongs = autolistsongsStr.equals("yes") || autolistsongsStr.equals("true");

	 String autolisttagsStr = Utility.configSet(config, "autolisttags", "yes").toLowerCase();
	 boolean autolisttags = autolisttagsStr.equals("yes") || autolisttagsStr.equals("true");

	 String autoupdatequeueStr = Utility.configSet(config, "autoupdatequeue", "yes").toLowerCase();
	 boolean autoupdatequeue = autoupdatequeueStr.equals("yes") || autoupdatequeueStr.equals("true");

	 if(debug > 1)
	 {
	    System.out.println("  debug            = " + debug);
	    System.out.println("  port             = " + port);
    	    System.out.println("  server           = " + server);
	    System.out.println("  autoconnect      = " + autoconnect);
	    System.out.println("  autolistsongs    = " + autolistsongs);
	    System.out.println("  autolisttags     = " + autolisttags);
	    System.out.println("  autoupdatequeue  = " + autoupdatequeue);
	 }

	 JFrame jf = new JFrame("Play GUI");
	 
	 jf.addWindowListener ( 
	    new WindowAdapter()
	    {
		  public void windowClosing(WindowEvent e)
		  {
		     System.exit(0);
		  }
	    } );
	 	 
	 PlayGui pg = new PlayGui(jf,port,server,debug);

	 if(autoconnect)
	    pg.connectToServer(server,port);
	 if(autolistsongs && pg.connected)
	    pg.updateSongList();
	 if(autolisttags && pg.connected)
	    pg.updateTags();
	 if(autolisttags && pg.connected)
	    pg.updateQueue();

	 jf.setSize(WIDTH,HEIGHT); 
	 jf.getContentPane().add(pg);
	 jf.show();
      }

      public void connectionDown()
      {
	 connected = false;
	 toggleConnect.setText("Connect");
	 setStatus("Not connected");
         Iterator it = offlineDisabledComponents.iterator(); 
         while(it.hasNext()) 
            ((Component)it.next()).setEnabled(false); 
      }

      public void reportError(String s)
      {
	 JOptionPane.showMessageDialog(frame,s,"Error",JOptionPane.ERROR_MESSAGE);
      }

      public void setStatus(String s)
      {
	 statusArea.setText(s);
      }
}

class Client extends Thread
{
      Socket soc;

      BufferedReader in;
      PrintWriter out;

      PlayGui contact;

      String host;
      int port;

      boolean done = false;

      private boolean avail = true;
     
      public Client(String host, int port, PlayGui contact)
      {
	 this.contact = contact;
	 this.host = host;
	 this.port = port;
      }

      public void run()
      {
	 while(!done)
	 {
	    Utility.sleep(1000);
	    if(contact.connected)
	    {
	       // notifications
	       String nots = checkNotifications();
	       if(nots != null && nots.length() > 0)
	       {
		  StringTokenizer st = new StringTokenizer(nots, "\n");
		  while(st.hasMoreTokens())
		  {
		     String tok = st.nextToken();
		     if(tok.equals("Update queue"))
			contact.updateQueue();
		     else if(tok.equals("Update tags"))
			contact.updateTags();
		  }
	       }

	       //status
	       String status = getStatus();

	       if(status == null)
	       {
		  contact.connectionDown();
		  contact.reportError("Couldn't read status from server, disconnecting.");
	       }
	       else if(status.startsWith("No File"))
		  contact.status = PlayGui.NO_FILE;
	       else
	       {
		  if(status.startsWith("Stopped"))
		  {
		     contact.status = PlayGui.STOPPED;
		     contact.togglePauseResumeButton.setText("Play");
		  }
		  else if(status.startsWith("Playing"))
		  {
		     contact.status = PlayGui.PLAYING;
		     contact.togglePauseResumeButton.setText("Pause");
		  }
		  else if(status.startsWith("Paused"))
		  {
		     contact.status = PlayGui.PAUSED;
		     contact.togglePauseResumeButton.setText("Play");
		  }
	       }
	    }
	 }
      }

      private synchronized boolean canTalk()
      {
	 if(!avail)
	    return false;
	 avail = false;
	 return true;
      }

      private void doneTalking()
      {
	 avail = true;
      }

      private void waitForAvailability()
      {
	 while(!canTalk())
	    Utility.sleep(100);
      }

      // returns null on success, an error message otherwise
      public String connect()
      {
	 soc = new Socket();

	 try
	 {
	    soc.connect(new InetSocketAddress(host, port));
	    
	    in = new BufferedReader (new InputStreamReader( soc.getInputStream() ));
	    out = new PrintWriter (new OutputStreamWriter (soc.getOutputStream() ), true);
	    
	    waitForAvailability();
	    String status = in.readLine();
	    doneTalking();

	    if(!status.startsWith("1 "))
	       return "Server: " + status.substring(2,status.length());
	 }
	 catch (IOException ioe)
	 {
	    return("Connection to server " + host + " failed.  Bummer dude.");
	 }

	 return null;
      }

      public void disconnect()
      {
	 try
	 {
	    soc.close();
	    contact.updateQueue();
	    contact.updateSongList();
	    contact.updateTags();
	 }
	 catch(IOException ioe)
	 {
	    if(contact.debug > 1)
	       System.out.println("Error in disconnecting from " + host + ".  Far out.");
	    contact.reportError("Can't disconnect from host.");
	 }
      }

      String nowPlaying()
      {
	 String n = lister("GetNowPlaying");
	 if(n != null)
	    return n.trim();
	 return null;
      }

      String checkNotifications()
      {
	 return lister("CheckNotifications");
      }

      String listSongs()
      {
	 return lister("ListSongs");
      }

      String listTags()
      {
	 return lister("ListTags");
      }

      String listTagsForSong(String song)
      {
	 return lister("ListTagsForSong " + song);
      }

      String listQueue()
      {
	 return lister("GetQueue");
      }
      String listHistory()
      {
	 return lister("GetHistory");
      }
      
      private String lister(String cmd)
      {
	 waitForAvailability();
	 out.println(cmd);

	 try 
	 {
	    StringBuffer ret = new StringBuffer();

	    String cur = in.readLine();
	    	    
	    while (cur!= null && !(cur.startsWith("0 ") || cur.startsWith("1 ")))
	    {
	       ret.append(cur  + "\n"); 
	       cur = in.readLine();
	    }

	    // cur now is a status code
	    
	    if(cur == null)
	    {
	       contact.connectionDown();
	       return "";
	    }

	    if(cur.startsWith("0 "))
	    {
	       contact.reportError("Server: \"" +
				   cur.substring(2,cur.length()) +
				   "\".  Disconnecting.");
	       contact.connectionDown();
	       return null;
	    }

	    doneTalking();

	    if(!"1 No notifications".equals(cur))
	       contact.setStatus("Server: \"" + cur.substring(2,cur.length()) + "\"");

	    if(contact.debug > 2)
	       System.out.println("Returning: " + ret.toString() + "\nReturned");
						
	    return ret.toString();
	 }
	 catch (IOException ioe)
	 {
	    contact.connectionDown();
	    contact.reportError("Couldn't read from host.  Sorry.");
	    doneTalking();
	    return null;
	 }
      }

 
      String multStr(String s, int times)
      {
	 StringBuffer t = new StringBuffer();
	 for(int i = 0 ; i < times ; i++)
	    t.append(s);
	 return t.toString();
      }


      private void simpleCommand(String cmd)
      {
	 waitForAvailability();

	 out.println(cmd);
	 try
	 {
	    String r = in.readLine();
	    if(r == null || !(r.startsWith(" 0") || r.startsWith("1 ")))
	    {
	       contact.connectionDown();
	       contact.reportError("Server not following protocall.  Recieved \"" + 
				   r + "\"");
	    }
	    else if(r.startsWith("0 "))
	       contact.reportError("Server: \"" +
				   r.substring(2,r.length()));
	    else // r.startsWith("1 ")
	       contact.setStatus("Server: \"" + r.substring(2,r.length()) + "\"");
	 }
	 catch (IOException ioe)
	 {
	    contact.connectionDown();
	    contact.reportError("Couldn't read from host.  Sorry.\n(command \"" + cmd + "\" failed.)");
	 }
	 doneTalking();
      }

      void removeFromHistory(int idx)
      {
	 simpleCommand("RemoveFromHistory " + idx);
      }

      void removeFromToplay(int idx)
      {
	 simpleCommand("RemoveFromToplay " + idx);
      }

      void clearToplay()
      {
	 simpleCommand("ClearQueue");
      }

      void clearHistory()
      {
	 simpleCommand("ClearHistory");
      }

      void pausee()
      {
	 simpleCommand("Pause");
      }

      void resumee()
      {
	 simpleCommand("Resume");
      }

      void startt()
      {
	 simpleCommand("Start");
      }

      void stopp()
      {
	 simpleCommand("Stop");
      }

      
      void next()
      {
	 simpleCommand("NextSong");
      }

      void nextN(int n)
      {
	 simpleCommand("NextSong " + n);
      }

      void prev()
      {
	 simpleCommand("PreviousSong");
      }

      void prevN(int n)
      {
	 simpleCommand("PreviousSong " + n);
      }

      String getStatus()
      {
	 String n = lister("Status");
	 if(n == null)
	    return null;
	 return n.trim();
      }

      String tagSearch(String expr)
      {
	 return lister("TagSearch " + expr);	 
      }

      void queueUpMult(Object[] songs)
      {
	 for(int i = 0 ; i < songs.length ; i++)
	    queueUp((String)songs[i]);
      }

      void tagMult(Object[] songs, String tag)
      {
	 for(int i = 0 ; i < songs.length ; i++)
	    tag((String)songs[i],tag);
      }

      void untagMult(Object[] songs, String tag)
      {
	 for(int i = 0 ; i < songs.length ; i++)
	    untag((String)songs[i],tag);
      }

      void newTag(String tag)
      {
	 simpleCommand("NewTag " + tag);
      }

      void tag(String song, String tag)
      {
	 simpleCommand("Tag " + tag + " " + song);
      }

      void untag(String song, String tag)
      {
	 simpleCommand("Untag " + tag + " " + song);
      }

      void removeTag(String tag)
      {
	 simpleCommand("DeleteTag " + tag);
      }

      void queueUp(String song)
      {
	 simpleCommand("QueueUpSong " + song);
      }
}

class TcActionListener implements ActionListener
{
      PlayGui contact;
      public TcActionListener(PlayGui contact)
      {
	 this.contact = contact;
      }

      public void actionPerformed(ActionEvent e)
      {
	 if (!contact.connected)
	    contact.connectToServer(contact.server,contact.port);
	 else
	    contact.disconnectFromServer();
      }
}

class UActionListener implements ActionListener
{
      public static final int 
      SONG=1, PLAY=2, QUEUE=3, NEXT=4, PREV=6,
	 QUEUE_SHUFFLED=7, CLEAR=9, CLEAR_FUTURE=10, CLEAR_HISTORY=11,
	 SEARCH=12, NEWTAG=13, TAG_BUTTON=14, UNTAG=15, REMOVE_TAG=16, UPDATE_TAGS=17,
	 QUEUE_REMOVE_BUTTON=18, TOGGLE_PAUSE_RESUME=19;

      PlayGui contact;
      int type;

      public UActionListener(PlayGui contact,int type)
      {
	 this.contact = contact;
	 this.type = type;
      }

      public void actionPerformed(ActionEvent e)
      {
	 if (contact.connected)
	 {
	    if(type == SONG)
	       contact.updateSongList();
	    else if(type == UPDATE_TAGS)
	       contact.updateSongList();
	    else if(type == PLAY)
	       contact.updateQueue();
	    else if(type == QUEUE)
	       contact.queueUp();
	    else if(type == QUEUE_SHUFFLED)
	       contact.queueUpShuffled();
	    else if(type == QUEUE_REMOVE_BUTTON)
	       contact.removeFromQueueButton();
	    else if(type == NEXT)
	       contact.next();
	    else if(type == PREV)
	       contact.prev();
	    else if(type == CLEAR)
	       contact.clearQueue();
	    else if(type == CLEAR_FUTURE)
	       contact.clearToplay();
	    else if(type == CLEAR_HISTORY)
	       contact.clearHistory();
	    else if(type == SEARCH)
	       contact.search();
	    else if(type == NEWTAG)
	       contact.newTagDotDotDot();
	    else if(type == REMOVE_TAG)
	       contact.removeTagDotDotDot();
	    else if(type == TAG_BUTTON)
	       contact.tagWindow();
	    else if(type == UNTAG)
	       contact.untagWindow();
	    else if(type == TOGGLE_PAUSE_RESUME)
	       contact.togglePauseResume();
	    else
	       Utility.die("Incorrect type " + type + " in UActionListener.");
	 }
      }
}

class TActionListener implements ActionListener
{
      public static final int TAG=1, REMOVE_TAG=2;


      String tag;
      int type;
      PlayGui contact;

      public TActionListener(String tag, int type, PlayGui contact)
      {
	 this.tag = tag;
	 this.type = type;
	 this.contact = contact;
      }

      public void actionPerformed(ActionEvent e)
      {
	 if(contact.connected)
	 {
	    if(type == TAG)
	       contact.tagSomething(tag);
/*	    else if (type == REMOVE_TAG)
	       contact.confirmRemoveTag(tag);
*/
	    else 
               Utility.die("Incorrect type " + type + " in TActionListener.");
	 }		  
      }
}

class PlMouseListener extends MouseAdapter
{		
      public static final int PLAY=1, SONG=2;
      
      int type;
      JList list;
      PlayGui contact;

      public PlMouseListener(PlayGui contact, JList list, int type)
      {
	 this.contact = contact;
	 this.list = list;
	 this.type = type;
      }

      public void mouseClicked(MouseEvent e) 
      {
	 if (type == PLAY)
	 {
	    if(e.getClickCount() == 2 && e.getButton() == e.BUTTON1)
	       contact.jumpToIndex( list.locationToIndex(e.getPoint()) );
	 }
	 else if(type == SONG)
	 {
	    if (e.getClickCount() == 2) // only add on double clicks
	       contact.queueSongByIndex(list.locationToIndex(e.getPoint()));
	 }
	 else 
	    Utility.die("Unknown type " + type + " in PlMouseListener");
      }

      public void mousePressed(MouseEvent e) 
      {
	 if(type == SONG || type == PLAY)
	    maybeShowPopup(e);
      }

      public void mouseReleased(MouseEvent e) 
      {
	 if(type == SONG || type == PLAY)
	    maybeShowPopup(e);
      }

      private void maybeShowPopup(MouseEvent e)
      {
	 if (e.isPopupTrigger() && contact.connected)
	 {
	    int clickIdx = list.locationToIndex(e.getPoint());

	    if(type == SONG)
	    {
	       if(list.isSelectionEmpty() || list.getSelectedValues().length == 1)
		  list.setSelectedIndex(clickIdx);
	       contact.songlistPopup.show(e.getComponent(),e.getX(),e.getY());
	    }
/*	    else if(type == PLAY)
	    {
	       contact.queueRightIndex = clickIdx;
	       contact.queuePopup.show(e.getComponent(),e.getX(),e.getY());
	    }
*/
	 }
      }
}

class jListCellRenderer extends DefaultListCellRenderer
{
      PlayGui contact;

      public jListCellRenderer(PlayGui contact)
      {
	 super();
	 this.contact = contact;
      }
      
      public Component getListCellRendererComponent(JList list, Object value,
						    int index, boolean isSelected, boolean cellHasFocus)
      {
	 Component c = super.getListCellRendererComponent(list,value,index,isSelected,cellHasFocus);
	 if(contact.histlines == index)
	    c.setFont(c.getFont().deriveFont(Font.BOLD));
	 return c;
      }
}
